#ifndef CCAMERAOBJECTSWRAPPERTOFUSIONCAMERADATA_H
#define CCAMERAOBJECTSWRAPPERTOFUSIONCAMERADATA_H
#include "wrappers/Fusion_GeneralWrapper.h"
#include <tuple>
extern "C" {
    #include "Fusion_SLAM_types.h"
	#include "fusion_ext.h"
}

class CCameraObjectsWrapperToFusionCameraData
{
private:

public:
    static std::tuple<Camera_input_lists, int> ConvertCamera2FusionCamera(perception::vector_CameraPerception2Fusion data)
	{
    	Camera_input_lists camList;
		int NumberOfObjects = data.size();
		if (NumberOfObjects == 0)
		{
			return {camList,NumberOfObjects};
		}
		int k = 0;
		for(auto & datum : data)
		{
			camList.Cameraobjlists[0].last_measure_update_timestamp_ns += datum.timestamp;
			camList.Cameraobjlists[0].Objects[k].track_id = datum.ID;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fAcc.data[0] = datum.acceleration.x;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fAcc.data[1] = datum.acceleration.y;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fAcc.data[2] = datum.acceleration.z;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovAcc.data[0][0] = datum.acceleration_covariance[0];
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovAcc.data[1][1] = datum.acceleration_covariance[1];
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovAcc.data[2][2] = datum.acceleration_covariance[2];
			camList.Cameraobjlists[0].Objects[k].Classification.type_confidence = datum.confidence;
			camList.Cameraobjlists[0].Objects[k].Geometry.height = datum.height;
			camList.Cameraobjlists[0].Objects[k].Geometry.length = datum.length;
			//datum.measurement_time;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fDist.data[0]  = datum.position.x;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fDist.data[1]  = datum.position.y;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fDist.data[2]  = datum.position.z;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovDist.data[0][0]  = datum.position_covariance[0];
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovDist.data[1][1]  = datum.position_covariance[1];
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovDist.data[2][2]  = datum.position_covariance[2];
			//datum.subtype;
			//camList.Cameraobjlists[0].Objects[k].Kinematic.fOrientation = datum.theta;
			camList.Cameraobjlists[0].Objects[k].Classification.ObjectType = datum.type;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fVel.data[0] = datum.velocity.x;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fVel.data[1] = datum.velocity.y;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fVel.data[2] = datum.velocity.z;
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovVel.data[0][0]  = datum.velocity_covariance[0];
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovVel.data[1][1]  = datum.velocity_covariance[1];
			camList.Cameraobjlists[0].Objects[k].Kinematic.fCovVel.data[2][2]  = datum.velocity_covariance[2];
			camList.Cameraobjlists[0].Objects[k].Geometry.width = datum.width;
			//camList.Objects[k].Attributes = tmpAtt;
			//camList.Objects[k].Classification
			//camList.Objects[k].Geometry = tmpGeo;
			k++;
		}
		camList.Cameraobjlists[0].last_measure_update_timestamp_ns /= NumberOfObjects;
		return {camList,NumberOfObjects};
	};
};

#endif // CLIDAROBJECTSWRAPPERTOFUSION_H
